<mat-card
  class="single-annotation-card resizable"
  [class.editmode]="isEditMode"
  [style.top.px]="annotation?.positionXOnView"
  [style.left.px]="annotation?.positionYOnView"
  *ngIf="visibility && annotation"
  [style.background-color]="'$cardbgr'"
  [id]="annotation._id"
>
  <form class="annotation-form" #annotationForm>
    <mat-error *ngIf="(isValid === false && isAnnotatingAllowed)"> 
      <span class="error-message">You must enter a title before saving this annotation</span>
    </mat-error>
    
    <mat-error *ngIf="!isAnnotatingAllowed && (!isWikibaseIdSet() || !isValid)">
      <p class="error-message">This annotation is not saved yet. Try refreshing your browser window.</p>
      <mat-expansion-panel class="error-message" *ngIf="!isWikibaseIdSet()">
        <mat-expansion-panel-header>
          <mat-panel-title class="icon-title">
            <mat-icon>info</mat-icon>
            <span>If the problem persists: why this annotation couldn't be saved?</span>
          </mat-panel-title>
        </mat-expansion-panel-header>
        <p>
          This annotation couldn't be saved because it has no Wikibase ID. To save it, you have to add a Title (mandatory) and a description (recommended).
        </p>
        <p *ngIf="adminContact">
          If you are stuck contact <a href="mailto:{{ adminContact }}">{{ adminContact }}</a> with the following information:  
        <p>
          <strong>Annotation ID:</strong> {{ annotation._id }}
        </p>
      </mat-expansion-panel>
    </mat-error>
    
    <mat-card-header>
      <button id="closeButton" mat-icon-button (click)="closeAnnotation()" type="button">
        <mat-icon aria-label="Close">cancel</mat-icon>
      </button>
      <mat-card-title>
        <span class="bigger-font" *ngIf="!isEditMode">{{ annotation.body.content.title }}</span>
        <mat-form-field *ngIf="isEditMode">
          <mat-label>Title</mat-label>
          <input
            matInput
            name="title"
            #title="ngModel"
            type="text"
            [(ngModel)]="annotation.body.content.title"
            required
          />
        </mat-form-field>
      </mat-card-title>
    </mat-card-header>

    <mat-card-content>
      <div *ngIf="isEditMode">
        <mat-form-field>
          <mat-label>Description</mat-label>
          <textarea
            #annotationContent
            matInput
            cdkTextareaAutosize
            cdkAutosizeMinRows="1"
            name="description"
            type="text"
            [(ngModel)]="annotation.body.content.description"
          ></textarea>
        </mat-form-field>
      </div>
      <markdown
        id="annotation-content"
        *ngIf="!isEditMode"
        [data]="annotation.body.content.description"
      ></markdown>
      <div *ngIf="annotation.body.content.relatedMediaUrls && !isEditMode">
        <div  *ngFor="let url of annotation.body.content.relatedMediaUrls"
        >
          <img
            class="related-media"
            [src]="url"
          />
      </div>
      </div>
      <div *ngIf="annotation.body.content.relatedMedia && annotation.body.content.relatedMedia.length && !isEditMode">
        <div  *ngFor="let medium of annotation.body.content.relatedMedia">
          
          <a href="/entity/{{medium.internalID}}" target="_blank" class="imageWithIcon">
            <img class="result-img" [src]="medium.media" />
            <div class="entity-type">
              <mat-icon
                class="button cursor-pointer"
                [matTooltip]="'Show preview'"
                >open_in_browser</mat-icon>
              </div>
          </a>
        </div>
      </div>      


      <!-- Rewrite the upper part so this is displayed as a proper angular card with image and title -->
      


      <div *ngIf="annotation.body.content.relatedEntities && annotation.body.content.relatedEntities.length && !isEditMode" class="item-results">
        <mat-card-header *ngFor="let concept of annotation.body.content.relatedEntities" class="item-result">
          <mat-card-title class="item-result-entry">
            <a target="_blank" [href]="concept.id">{{ concept.label['en'] }}</a>
          </mat-card-title>
        </mat-card-header>
      </div>

      
    </mat-card-content>

    <mat-card-actions>
      <button
        mat-icon-button
        (click)="editFullscreen()"
        matTooltip="Edit in Fullscreen Mode"
        matTooltipPosition="above"
        type="button"
        *ngIf="isAnnotatingAllowed && isAnnotationOwner"
      >
        <mat-icon aria-label="Fullscreen">select_all</mat-icon>
      </button>

      <button
        mat-icon-button
        (click)="toggleEditViewMode()"
        [matTooltip]="isEditMode ? 'Save Annotation' : 'Edit Annotation'"
        *ngIf="isAnnotatingAllowed && isAnnotationOwner"
        matTooltipPosition="above"
        type="button"
      >
        <mat-icon [attr.aria-label]="isEditMode ? 'Save Annotation' : 'Edit Annotation'">{{
          isEditMode ? 'save' : 'edit'
        }}</mat-icon>
      </button>

      <button
        *ngIf="isAnnotatingAllowed && isAnnotationOwner"
        mat-icon-button
        (click)="deleteAnnotation()"
        matTooltip="Delete"
        matTooltipPosition="above"
        type="button"
      >
        <mat-icon aria-label="Delete">delete</mat-icon>
      </button>
    </mat-card-actions>
  </form>
</mat-card>
